using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MccDaq;

namespace DigitalBitIn
{
    public partial class Form1 : Form
    {
        public MccDaq.MccBoard DaqBoard;
        public MccDaq.ErrorInfo ULStat;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //First Lets make sure there's a USB-2408 of some kind plugged in,
            //then we'll check to see if it has analog outputs.
            System.Int16 BoardNum;
            System.Boolean Boardfound = false;
            for (BoardNum = 0; BoardNum < 99; BoardNum++)
            {

                DaqBoard = new MccDaq.MccBoard(BoardNum);
                if (DaqBoard.BoardName.Contains("2408-2AO"))
                {
                    Boardfound = true;
                    this.Text = "2408-2AO found as board number: " + BoardNum.ToString();
                    ULStat = DaqBoard.FlashLED();
                    break;
                }

                if (DaqBoard.BoardName.Contains("2408"))
                {
                    Boardfound = true;
                    this.Text = "USB-2408 found as board number: " + BoardNum.ToString();
                    DaqBoard.FlashLED();
                    break;
                }
            }

            if (Boardfound == false)
            {
                System.Windows.Forms.MessageBox.Show("No USB-2408 series board found in system.  Please run InstaCal.", "No Board detected");
                this.Close();
            }
            this.tmrDigitalBitIn.Enabled = true;
        }

        private void btnEnd_Click(object sender, EventArgs e)
        {
            tmrDigitalBitIn.Enabled = false;
            this.Close();
        }

        private void tmrDigitalBitIn_Tick(object sender, EventArgs e)
        {
            MccDaq.DigitalLogicState bitval; 

	        ULStat = DaqBoard.DBitIn(MccDaq.DigitalPortType.FirstPortA, 0,out bitval);
			lblStatus.Text = "Status:  " + ULStat.Message;
			if (bitval == MccDaq.DigitalLogicState.High ) pbBit0.BackColor = Color.LimeGreen; else pbBit0.BackColor = Color.DarkGreen;

            ULStat = DaqBoard.DBitIn(MccDaq.DigitalPortType.FirstPortA, 1, out bitval);
			if (bitval == MccDaq.DigitalLogicState.High ) pbBit1.BackColor = Color.LimeGreen; else pbBit1.BackColor = Color.DarkGreen;

            ULStat = DaqBoard.DBitIn(MccDaq.DigitalPortType.FirstPortA, 2, out bitval);
			if (bitval == MccDaq.DigitalLogicState.High ) pbBit2.BackColor = Color.LimeGreen; else pbBit2.BackColor = Color.DarkGreen;

            ULStat = DaqBoard.DBitIn(MccDaq.DigitalPortType.FirstPortA, 3, out bitval);
			if (bitval == MccDaq.DigitalLogicState.High ) pbBit3.BackColor = Color.LimeGreen; else pbBit3.BackColor = Color.DarkGreen;

            ULStat = DaqBoard.DBitIn(MccDaq.DigitalPortType.FirstPortA, 4, out bitval);
			if (bitval == MccDaq.DigitalLogicState.High ) pbBit4.BackColor = Color.LimeGreen; else pbBit4.BackColor = Color.DarkGreen;

            ULStat = DaqBoard.DBitIn(MccDaq.DigitalPortType.FirstPortA, 5, out bitval);
			if (bitval == MccDaq.DigitalLogicState.High ) pbBit5.BackColor = Color.LimeGreen; else pbBit5.BackColor = Color.DarkGreen;

            ULStat = DaqBoard.DBitIn(MccDaq.DigitalPortType.FirstPortA, 6, out bitval);
			if (bitval == MccDaq.DigitalLogicState.High ) pbBit6.BackColor = Color.LimeGreen; else pbBit6.BackColor = Color.DarkGreen;

            ULStat = DaqBoard.DBitIn(MccDaq.DigitalPortType.FirstPortA, 7, out bitval);
			if (bitval == MccDaq.DigitalLogicState.High ) pbBit7.BackColor = Color.LimeGreen; else pbBit7.BackColor = Color.DarkGreen;
        }
    }
}