using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MccDaq;

namespace DigitalBitOut
{
    public partial class Form1 : Form
    {
        public MccDaq.MccBoard DaqBoard;
        public MccDaq.ErrorInfo ULStat;
        public MccDaq.Range Range;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //First Lets make sure there's a USB-2408 of some kind plugged in,
            //then we'll check to see if it has analog outputs.
            System.Int16 BoardNum;
            System.Boolean Boardfound = false;
            for (BoardNum = 0; BoardNum < 99; BoardNum++)
            {

                DaqBoard = new MccDaq.MccBoard(BoardNum);
                if (DaqBoard.BoardName.Contains("2408-2AO"))
                {
                    Boardfound = true;
                    this.Text = "2408-2AO found as board number: " + BoardNum.ToString();
                    ULStat = DaqBoard.FlashLED();
                    break;
                }

                if (DaqBoard.BoardName.Contains("2408"))
                {
                    Boardfound = true;
                    this.Text = "USB-2408 found as board number: " + BoardNum.ToString();
                    DaqBoard.FlashLED();
                    break;
                }
            }

            if (Boardfound == false)
            {
                System.Windows.Forms.MessageBox.Show("No USB-2408 series board found in system.  Please run InstaCal.", "No Board detected");
                this.Close();
            }
            //Set the ports' configuration to output
            ULStat = DaqBoard.DConfigPort(MccDaq.DigitalPortType.FirstPortA, MccDaq.DigitalPortDirection.DigitalOut);
            lblStatus.Text = "Status:  " + ULStat.Message;
        }

        public void SetBitVal(System.Int16 BitNumber)
        {
            /*So as not to repeat the same routine 8 times,  This subroutine is called each time the user clicks on a
            specific bit's related checkbox.  This way there is only one place to look for and modify the DBitOut method
                
            Use the bitnum find out if the objects text is Off or On.  Changes the text of the object from Off to On or 
            On to Off, and change the state of the related bit appropriately.*/
            MccDaq.DigitalLogicState MyBitVal;
            MyBitVal = MccDaq.DigitalLogicState.Low;
            switch (BitNumber)
            {
                case 0:
                    if (chkBit0.Checked == true)
                    {
                        chkBit0.Text = "On";
                        MyBitVal = MccDaq.DigitalLogicState.High;
                    }
                    else
                    {
                        chkBit0.Text = "Off";
                        MyBitVal = MccDaq.DigitalLogicState.Low;
                    }
                    break;

                case 1:
                    if (chkBit1.Checked == true)
                    {
                        chkBit1.Text = "On";
                        MyBitVal = MccDaq.DigitalLogicState.High;
                    }
                    else
                    {
                        chkBit1.Text = "Off";
                        MyBitVal = MccDaq.DigitalLogicState.Low;
                    }
                    break;

                case 2:
                    if (chkBit2.Checked == true)
                    {
                        chkBit2.Text = "On";
                        MyBitVal = MccDaq.DigitalLogicState.High;
                    }
                    else
                    {
                        chkBit2.Text = "Off";
                        MyBitVal = MccDaq.DigitalLogicState.Low;
                    }
                    break;

                case 3:
                    if (chkBit3.Checked == true)
                    {
                        chkBit3.Text = "On";
                        MyBitVal = MccDaq.DigitalLogicState.High;
                    }
                    else
                    {
                        chkBit3.Text = "Off";
                        MyBitVal = MccDaq.DigitalLogicState.Low;
                    }
                    break;

                case 4:
                    if (chkBit4.Checked == true)
                    {
                        chkBit4.Text = "On";
                        MyBitVal = MccDaq.DigitalLogicState.High;
                    }
                    else
                    {
                        chkBit4.Text = "Off";
                        MyBitVal = MccDaq.DigitalLogicState.Low;
                    }
                    break;

                case 5:
                    if (chkBit5.Checked == true)
                    {
                        chkBit5.Text = "On";
                        MyBitVal = MccDaq.DigitalLogicState.High;
                    }
                    else
                    {
                        chkBit5.Text = "Off";
                        MyBitVal = MccDaq.DigitalLogicState.Low;
                    }
                    break;

                case 6:
                    if (chkBit6.Checked == true)
                    {
                        chkBit6.Text = "On";
                        MyBitVal = MccDaq.DigitalLogicState.High;
                    }
                    else
                    {
                        chkBit6.Text = "Off";
                        MyBitVal = MccDaq.DigitalLogicState.Low;
                    }
                    break;

                case 7:
                    if (chkBit7.Checked == true)
                    {
                        chkBit7.Text = "On";
                        MyBitVal = MccDaq.DigitalLogicState.High;
                    }
                    else
                    {
                        chkBit7.Text = "Off";
                        MyBitVal = MccDaq.DigitalLogicState.Low;
                    }
                    break;
            }

            //Use the selected bitNumber and bitvalue to send out via DBitOut
            ULStat = DaqBoard.DBitOut(MccDaq.DigitalPortType.FirstPortA, BitNumber, MyBitVal);
            lblStatus.Text = "Status:  " + ULStat.Message;
        }

        private void chkBit0_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(0);
        }

        private void chkBit1_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(1);
        }

        private void chkBit2_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(2);
        }

        private void chkBit3_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(3);
        }

        private void chkBit4_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(4);
        }

        private void chkBit5_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(5);
        }

        private void chkBit6_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(6);
        }

        private void chkBit7_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(7);
        }

        private void chkBit8_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(8);
        }

        private void chkBit9_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(9);
        }

        private void chkBit10_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(10);
        }

        private void chkBit11_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(11);
        }

        private void chkBit12_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(12);
        }

        private void chkBit13_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(13);
        }

        private void chkBit14_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(14);
        }

        private void chkBit15_CheckedChanged(object sender, EventArgs e)
        {
            SetBitVal(15);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Set all the bits to off, and end the program.
            System.UInt16 DataVal = 0;
            ULStat = DaqBoard.DOut(MccDaq.DigitalPortType.FirstPortA, DataVal);
            this.Close();
        }
    }
}