using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MccDaq;

namespace DigitalIn
{
    public partial class Form1 : Form
    {
        public MccDaq.MccBoard DaqBoard;
        public MccDaq.ErrorInfo ULStat;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //First Lets make sure there's a USB-2408 of some kind plugged in,
            //then we'll check to see if it has analog outputs.
            System.Int16 BoardNum;
            System.Boolean Boardfound = false;
            for (BoardNum = 0; BoardNum < 99; BoardNum++)
            {

                DaqBoard = new MccDaq.MccBoard(BoardNum);
                if (DaqBoard.BoardName.Contains("2408-2AO"))
                {
                    Boardfound = true;
                    this.Text = "2408-2AO found as board number: " + BoardNum.ToString();
                    ULStat = DaqBoard.FlashLED();
                    break;
                }

                if (DaqBoard.BoardName.Contains("2408"))
                {
                    Boardfound = true;
                    this.Text = "USB-2408 found as board number: " + BoardNum.ToString();
                    DaqBoard.FlashLED();
                    break;
                }
            }

            if (Boardfound == false)
            {
                System.Windows.Forms.MessageBox.Show("No USB-2408 series board found in system.  Please run InstaCal.", "No Board detected");
                this.Close();
            }
            this.tmrDigitalInput.Enabled = true;
        }

        private void Button6_Click(object sender, EventArgs e)
        {
            tmrDigitalInput.Enabled = false;
            this.Close();
        }

        private void tmrDigitalInput_Tick(object sender, EventArgs e)
        {
            System.UInt16 PortVal, a, result;
			
			//Read in all 8 bits using the DIn() method.
			ULStat = DaqBoard.DIn(MccDaq.DigitalPortType.FirstPortA, out PortVal);
			lblStatus.Text = "Status:  " + ULStat.Message;

			//Decode the data by AND-ing the variable (PortVal) with each bit raised to the power of 2.
			a = (ushort)System.Math.Pow(2, 0);
            result = Convert.ToUInt16(PortVal & a);
            if (result == 1) pbBit0.BackColor = Color.LimeGreen; else pbBit0.BackColor = Color.DarkGreen;

            a = (ushort)System.Math.Pow(2, 1);
            result = Convert.ToUInt16(PortVal & a);
            if (result == 2) pbBit1.BackColor = Color.LimeGreen; else pbBit1.BackColor = Color.DarkGreen;

            a = (ushort)System.Math.Pow(2, 2);
            result = Convert.ToUInt16(PortVal & a);
            if (result == 4) pbBit2.BackColor = Color.LimeGreen; else pbBit2.BackColor = Color.DarkGreen;

            a = (ushort)System.Math.Pow(2, 3);
            result = Convert.ToUInt16(PortVal & a);
            if (result == 8) pbBit3.BackColor = Color.LimeGreen; else pbBit3.BackColor = Color.DarkGreen;

            a = (ushort)System.Math.Pow(2, 4);
            result = Convert.ToUInt16(PortVal & a);
            if (result == 16) pbBit4.BackColor = Color.LimeGreen; else pbBit4.BackColor = Color.DarkGreen;

            a = (ushort)System.Math.Pow(2, 5);
            result = Convert.ToUInt16(PortVal & a);
            if (result == 32) pbBit5.BackColor = Color.LimeGreen; else pbBit5.BackColor = Color.DarkGreen;

            a = (ushort)System.Math.Pow(2, 6);
            result = Convert.ToUInt16(PortVal & a);
            if (result == 64) pbBit6.BackColor = Color.LimeGreen; else pbBit6.BackColor = Color.DarkGreen;

            a = (ushort)System.Math.Pow(2, 7);
            result = Convert.ToUInt16(PortVal & a);
            if (result == 128) pbBit7.BackColor = Color.LimeGreen; else pbBit7.BackColor = Color.DarkGreen;
        }
    }
}