using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MccDaq;

namespace AnalogIn
{
    
    public partial class Form1 : Form
    {
        private MccDaq.MccBoard DaqBoard;
        private MccDaq.ErrorInfo ULStat;
        private MccDaq.Range Range;
        System.Int32 numchannels;
        public Form1()
        {
            InitializeComponent();
            //Here's where we declare our variables for the project
		
        }

        private void Form1_Load(object sender, EventArgs e) 
        {
            //First Lets make sure there's a USB-2408 of some kind plugged in,
            //then we'll check to see if it has analog outputs.
			System.Int16 BoardNum;
			System.Boolean Boardfound  = false;
			for( BoardNum = 0;BoardNum < 99; BoardNum++)
            {

			    DaqBoard =new  MccDaq.MccBoard(BoardNum);
                if (DaqBoard.BoardName.Contains("2408-2AO"))
                    {   
                        Boardfound = true;
                        this.Text = "2408-2AO found as board number: " + BoardNum.ToString();
                        ULStat = DaqBoard.FlashLED();
                        break;
                    }

                if (DaqBoard.BoardName.Contains("2408"))
                    {
                        Boardfound = true;
                        this.Text = "USB-2408 found as board number: " + BoardNum.ToString();
                        DaqBoard.FlashLED();
                        break;
                    }
            }

		    if (Boardfound == false){
                System.Windows.Forms.MessageBox.Show("No USB-2408 series board found in system.  Please run InstaCal.", "No Board detected");
                this.Close();
		    }

            LoadComboBox(cmboAInRange);

            //Determine if the device is set for single ended or differential by the number of channels.
            DaqBoard.BoardConfig.GetNumAdChans(out numchannels);
            nudAInChannel.Maximum = numchannels;
	    }

        private void btnGetOneDataPointUsingAIn_Click(object sender, EventArgs e)
        {
            System.Int32 dataval;
            System.Double engunits;

            SelectRange(cmboAInRange.SelectedIndex);

            System.Int32 Options = 0;

            ULStat = DaqBoard.AIn32(Convert.ToInt32(nudAInChannel.Value), Range, out dataval, Options);
            lblAInStatus.Text = ULStat.Message;
            lblDataVal.Text = dataval.ToString();

            ULStat = DaqBoard.ToEngUnits32(Range, dataval,out engunits);
            lblEngUnits.Text = engunits.ToString();
        }

        private void btnGetOneDataPointUsingVIn_Click(object sender, EventArgs e)
        {
            System.Single VInVolts;

            SelectRange(cmboAInRange.SelectedIndex);

            ULStat = DaqBoard.VIn(Convert.ToInt16(nudAInChannel.Value), Range,out VInVolts, MccDaq.VInOptions.Default);
            lblAInStatus.Text = ULStat.Message;

            lblVIn.Text = VInVolts.ToString();
        }

        private void Button6_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        public void LoadComboBox(ComboBox sender)
        {
            sender.Items.Add( "BIP10VOLTS");
            sender.Items.Add( "BIP5VOLTS");
            sender.Items.Add("BIP2PT5VOLTS");
            sender.Items.Add("BIP1PT25VOLTS");
            sender.Items.Add("BIPPT625VOLTS");
            sender.Items.Add("BIPPT312VOLTS");
            sender.Items.Add("BIPPT156VOLTS");
            sender.Items.Add("BIPPT078VOLTS"); 
            sender.SelectedIndex = 0;
        }

        public void SelectRange(Int32 ComboBoxIndex )  
        {
            switch  (ComboBoxIndex)
            {
                case 0:
                    Range = MccDaq.Range.Bip10Volts;
                    break;
                case 1:
                    Range = MccDaq.Range.Bip5Volts;
                    break;
                case 2:
                    Range = MccDaq.Range.Bip2Pt5Volts;
                    break;
                case 3:
                    Range = MccDaq.Range.Bip1Pt25Volts;
                    break;
                case 4:
                    Range = MccDaq.Range.BipPt625Volts;
                    break;
                case 5:
                    Range = MccDaq.Range.BipPt312Volts;
                    break;
                case 6:
                    Range = MccDaq.Range.BipPt156Volts;
                    break;
                case 7:
                    Range = MccDaq.Range.BipPt078Volts;
                    break;
            }

        }
    }
}
